//+------------------------------------------------------------------+
//|                                                  Custom MACD.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2010 FXWolfPack"
#property  link      "Alex Pressl"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  Green
#property  indicator_color2  Red
#property  indicator_color3  Silver
#property  indicator_width1  2
#property  indicator_width2  2

#property indicator_level1 0
//---- indicator parameters
extern int FirstOrderIndex=1;    //omit deposit order
//---- indicator buffers
double     ProfitBuffer[];
double     LossBuffer[];
double     BalanceBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_LINE);
   IndicatorDigits(1);
//---- indicator buffers mapping
   SetIndexBuffer(0,ProfitBuffer);
   SetIndexBuffer(1,LossBuffer);
   SetIndexBuffer(2,BalanceBuffer);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("ProfitLoss");
   SetIndexLabel(0,"Profit");
   SetIndexLabel(1,"Loss");
   SetIndexLabel(2,"Balance");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//|                            |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

   int total=OrdersHistoryTotal();
   int cnt=0;

   
   if(total>0)
   {
     for(cnt=total-1;cnt>=FirstOrderIndex;cnt--)
     {
        OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY);
        if (OrderSymbol()!=Symbol()) continue;
        
        double Profit = OrderProfit();
        datetime tOpen= OrderOpenTime();
        int index = (Time[0]-tOpen)/(Period()*60);
        if (Profit>0)
            ProfitBuffer[index]=Profit;
        else
            LossBuffer[index]=Profit;
     }
   }
   OrderSelect(0,SELECT_BY_POS,MODE_HISTORY);
   
//   double Balance=OrderProfit();
   double Balance=0;
   for(cnt=index;cnt>=0;cnt--)
   {
      if (ProfitBuffer[cnt]!=EMPTY_VALUE)
         Balance=Balance+ProfitBuffer[cnt];
      if (LossBuffer[cnt]!=EMPTY_VALUE)
         Balance=Balance+LossBuffer[cnt];
      BalanceBuffer[cnt]=Balance;
   }




//---- done
   return(0);
  }
//+------------------------------------------------------------------+